/* findhier.h
 * last revised at 8, Apr. 1994
 *
 * Copyright (C) 1994, All rights reserved.
 * written by Gyudong Kim(chilly@eleceng.adelaide.edu.au)
 *
 */
#include <stdio.h>
#include <string.h>
#include "fstruct.h"

#define warning(A,B) if (fprintf(stderr,A,B)==EOF) exit(-1)
#define BUFSIZE 256
#define PATHLEN 1024
#define BELL 7
#define DEFNUMFORMAT 'f'
#define CIFTOP "#CiFToP"

#define bell() warning("%c",BELL)
#ifdef SYSV
#define myfree(A) (void)free((void *)(A))
#define SIZE int
#define MEMT void
#else
#define myfree(A) (void)free((char *)(A))
#define SIZE unsigned int
#define MEMT char
#endif
#define fgetc getc
#define BIG(A) (((A) >> 8) & 0xff | (((A) & 0xff) << 8))

#ifndef isalpha
#define isalpha(X) ( X>='A' && X<='Z' || X>='a' && X<='z' )
#endif isalpha

typedef enum formats { CIF, GDSII, MAGIC, PCSTR, VALID, TeX } FORMAT;

/* fnames.c */
	char *basename();
	char *dirname();
/* family.c */
	void included();
/* valid.c */
	void GED_init();
	void GED_tree();
/* vacant.c */
	void vacant();
	int isvacant();
/* trees.c */
	void make_tree();
	void add_cell();
/* tex.c */
	char *get_tex();
/* reverse.c */
	struct branch *find_top();
	int reverse();
/* redirect.c */
	void redirect();
/* prune.c */
	void prune();
/* out.c */
	int out_branch();
	int dangling();
	void listing();
	void top_list();
	void out_graph();
/* names.c */
	char *global();
	int glob_error();
	void create();
	char *extension();
	void name_list();
/* myalloc.c */
	void *myalloc();
	void freelink();
/* menu.c */
	void menu();
	char *get_cmd();
/* magic.c */
	void myenviron();
/* loop.c */
	void push();
	void pop();
	int check();
/* input.c */
	void seek_char();
	char *getmagline();
/* graft.c */
	int find_parent();
	void graft();
/* gdsii.c */
	void set_byte_order();
	char *pcstream_read();
	void gds_init();
	void gds_tree();
/* cif.c */
	char *cif_global();
	void cif_tree();
	void cif_init();
/* options.c */
	void mygetopt();
	void no_target();
/* string.c */
#ifdef strcmpi
#undef strcmpi
#endif
	int strcmpi();
	char *strlwr();
	char *dummycase();

void exit();
char *getenv();

#ifdef SYSV
void *malloc();
void free();
#else
char *malloc();
#endif SYSV
#ifdef _UNIX_
#	define OPENMODE "r"
#	define DIRDEL '/'
#else
#define OPENMODE "rb"
#define DIRDEL '\\'
#endif _UNIX_
/*
char *getenv();
*/

/* findhier.h */
