/* tex.c
 * last revised at 15, Oct. 1995
 *
 * TeX input
 * Copyright (C) 1995, All rights reserved.
 * written by Gyudong Kim(chilly@iclab.snu.ac.kr)
 *
 */
#include "findhier.h"

static char buf[BUFSIZE];

static void look_for_bs(tex)
FILE *tex;
{
	register int c;

	while ((c = fgetc(tex))!=EOF) {
		switch (c) {

		case '%':
			seek_char('\n',tex);
			break;
		case '\\':
			return;
		default:
			continue;
		}
	}
	return;
}

static int skip_blank(tex)
FILE *tex;
{
	register int c;

	while((c=fgetc(tex))!=EOF) {
		switch (c) {
		
		case ' ':
		case '\t':
		case '\n':
			continue;
		case '%':
			seek_char('\n',tex);
			break;
		default:
			return(c);
		}
	}
	return(EOF);
}

static char *token(tex)
FILE *tex;
{
	register int c,i;

	i = 0;
	c = skip_blank(tex);
	switch (c) {
		case EOF:
			return((char *)NULL);
		case '{':
			c = skip_blank(tex);
		default:
			do {
				if (isspace(c)
					|| i>=BUFSIZE-1
					|| c=='{'
					|| c=='}'
					|| c=='\\') {
					break;
				}
				buf[i]=c;
				i++;
				c = fgetc(tex);
			} while (c!=EOF);
			break;
	}
	buf[i]=0;
	return(buf);
}

static char *texgets(str,len,file)
char *str;
int len;
FILE *file;
{
	int i=0;
	int c;

	while(i<len) {
		c = fgetc(file);
		switch (c) {
			case EOF:
				return((char *)NULL);
			case '%':
				seek_char('\n',file);
				break;
			case '\\':
				i=0;
				break;
			default:
				str[i]=c;
				i++;
				break;
		}
	}
	return(str);
}

/*
 * ignore prefixed spaces
 * ignore comments which starts with '%' to EOLN
 * look for '\\'
 * determine the first word is "input"
 * if not, continue
 * if so, get the next word which may or may not be encapsulated with '{}'
 * & return the word
 */
char *get_tex(tex)
FILE *tex;
{
	char cmd[6];

	do {
		look_for_bs(tex);
		if (texgets(cmd,6,tex)==NULL) return((char *)NULL);
	} while (strncmp(cmd,"input",5));
	return(token(tex));
}
/* tex.c */
